<template>
  <div>
    <v-text-field
      v-bind="$attrs"
      :value="colorName"
      :label="$t('color')"
      :append-icon="appendIcon"
      readonly
      v-on="$listeners"
      @click="toggleColorPicker"
      @click:append="toggleColorPicker"
    >
      <template v-slot:prepend>
        <paint-bucket-icon :color="color" />
      </template>
    </v-text-field>
    <v-color-picker
      v-show="showColorPicker"
      :value="color"
      hide-canvas
      hide-sliders
      hide-inputs
      show-swatches
      swatches-max-height="250"
      width="552"
      mode="hexa"
      elevation="3"
      @input="$emit('input', $event)"
    />
  </div>
</template>

<script>
  import { nameThatColor } from '@/plugins'

  const WITHOUT_COLOR = '#00000000'

  export default {
    name: 'ColorPickerField',
    inheritAttrs: false,
    props: {
      value: {
        type: String,
        required: false,
        default: WITHOUT_COLOR,
      },
    },
    data () {
      return {
        nameThatColor: null,
        showColorPicker: false,
      }
    },
    computed: {
      appendIcon () {
        return this.showColorPicker ? 'mdi-chevron-up' : 'mdi-chevron-down'
      },
      color () {
        return !this.value
          ? WITHOUT_COLOR
          : this.value
      },
      colorName () {
        return this.value === WITHOUT_COLOR
          ? ''
          : nameThatColor(this.value)
      },
    },
    created () {
      this.$emit('closeColorPicker', this.closeColorPicker)
    },
    methods: {
      toggleColorPicker () {
        this.showColorPicker = !this.showColorPicker
      },
      closeColorPicker () {
        this.showColorPicker = false
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          color: 'Cor',
        },
        'en-US': {
          color: 'Color',
        },
      },
    },
  }
</script>
